from math import ceil,floor
from cypari import pari

isprime = pari("isprime")
round = pari("round")

#fast integer square root
def sqr_root(n):    
  x=2**ceil(n.bit_length()/2.)
  y=floor((x+floor(n/x))/2.)
  while y<x:
    x=y
    y=floor((x+floor(n/x))/2.)
  return(x)

#fast integer root test
def is_power(n,p=0):
  global isprime, round
  a=floor(sqr_root(n));  
  if a*a==n: return True
  if p==2: return False
  b = n.bit_length() #note only after python >= 2.7.. len(binary(n));  
  for i in xrange(3,b):
    if (p!=0 and i>p): return False
    if isprime(i):
      r = 1/pari(i) #we need to tell pari it is a fraction, otherwise python floors the fraction 
      a=round(n**r)
      if a**i==n: return True      
  return False
